<template lang="html">
  <header class="header" :class="{ 'dark': darkHeader }"
    v-on:click="setDarkHeader(false)">
    <div class="content">
      <div class="home-btn-container">
        <button type="button"
          v-on:click="navigateHome()"
          class="home-btn">
          <svg class="home-btn-icon btn-icon" width="32" height="32" viewBox="0 0 200 200" xmlns="http://www.w3.org/2000/svg"><title>Enoplay</title><path d="M180 160.01V160h-80v40C44.772 200 0 155.228 0 100S44.772 0 100 0s100 44.772 100 100c0 22.516-7.442 43.295-20 60.01zM100 120c11.046 0 20-8.954 20-20s-8.954-20-20-20-20 8.954-20 20 8.954 20 20 20z" fill="#000" fill-rule="evenodd"/></svg>
        </button>
      </div>
      <div class="menu">
        <!--
        <div class="search-btn-container">
          <button type="button" class="search-btn">
            <svg class="search-btn-icon btn-icon" width="24" height="24" viewBox="0 0 48 48" xmlns="http://www.w3.org/2000/svg"><title>Search Enoplay</title><path d="M47.361 44.275L34.979 31.893c2.687-3.36 4.294-7.62 4.294-12.257C39.273 8.792 30.48 0 19.636 0 8.792 0 0 8.792 0 19.636c0 10.845 8.792 19.637 19.636 19.637 4.637 0 8.898-1.607 12.257-4.295L44.275 47.36c.426.426.985.64 1.543.64.558 0 1.117-.214 1.543-.64.852-.851.852-2.233 0-3.085zM19.636 34.91c-8.435 0-15.272-6.838-15.272-15.273 0-8.435 6.837-15.272 15.272-15.272 8.436 0 15.273 6.837 15.273 15.272S28.072 34.91 19.636 34.91z" fill-rule="nonzero" fill="#000"/></svg>
          </button>
        </div>
        -->
        <div class="menu-btn-container">
          <button type="button" class="menu-btn" v-on:click="showMenu()">
            <svg class="menu-btn-icon btn-icon" width="24" height="24" viewBox="0 0 24 24" xmlns="http://www.w3.org/2000/svg"><g fill-rule="nonzero" fill="#000"><path d="M12 24C5.4 24 0 18.6 0 12S5.4 0 12 0s12 5.4 12 12-5.4 12-12 12zm0-22C6.5 2 2 6.5 2 12s4.5 10 10 10 10-4.5 10-10S17.5 2 12 2z"/><circle cx="7" cy="12" r="2"/><circle cx="12" cy="12" r="2"/><circle cx="17" cy="12" r="2"/></g></svg>
          </button>
        </div>
      </div>
      <h1 class="title">{{ headerTitle }}</h1>
    </div>
  </header>
</template>

<script>
import { mapState, mapActions } from 'vuex'

export default {
  name: 'ep-header',
  data () {
    return { }
  },
  computed: {
    ...mapState('app', [
      'headerTitle',
      'darkHeader',
      'dialogTypes'
    ])
  },
  methods: {
    ...mapActions('app', [
      'selectDialog',
      'setDarkHeader'
    ]),
    showMenu () {
      this.selectDialog({
        dialog: this.dialogTypes.menu
      })
    },
    navigateHome () {
      if (window.location.pathname !== '/') {
        this.$router.push({ name: 'index' })
      }
    }
  }
}
</script>

<style lang="scss" scoped>
@import '~assets/styles/input';
@import '~assets/styles/theme';

$header-height: 46px;
$font-size: 15px;

$home-icon-size: 32px;

$menu-icon-padding: 32px;
$search-icon-size: 24px;
$menu-icon-size: 24px;

$transition-speed: 2s;

$icon-color-light: #566473;

.header {
  display: block;
  position: relative;
  height: $header-height;
  background: #fff;
}

.content {
  .title {
    display: table-cell;
    vertical-align: middle;
    height: $header-height;
    margin: 0;
    color: $app-theme-color;
    font-size: $font-size;
  }

  .menu {
    float: right;
    display: inline-block;
  }
}

.home-btn-container, .search-btn-container, .menu-btn-container {
  height: $header-height;
}

.search-btn-container, .menu-btn-container {
  display: table-cell;
}

.home-btn-container {
  float: left;
  margin-right: 8px;
  margin-left: 16px;
}

.menu-btn-container {
  margin-right: 4px;
}

.home-btn, .search-btn, .menu-btn {
  display: block;
  height: 100%;
  border: 0;
  margin: 0;
  padding: 0;
  background: transparent;
}

.search-btn, .menu-btn {
  padding-left: $menu-icon-padding;
}

.home-btn-icon, .search-btn-icon, .menu-btn-icon {
  display: block;
}

.home-btn-icon {
  width: $home-icon-size;
  height: $home-icon-size;
  path {
    fill: $app-theme-color;
  }
}

.search-btn-icon {
  width: $search-icon-size;
  height: $search-icon-size;
  path {
    fill: $app-theme-color;
  }
}

.menu-btn-icon {
  margin-right: 16px;
  width: $menu-icon-size;
  height: $menu-icon-size;
  path, circle {
    fill: $app-theme-color;
  }
}

.dark {
  animation-name: darkFade;
  animation-duration: $transition-speed;
  animation-fill-mode: forwards;

  .title {
    color: $icon-color-light;
  }
  .btn-icon {
    path {
      fill: $icon-color-light;
    }
    circle {
      fill: $icon-color-light;
    }
  }
}

@keyframes darkFade {
  from { background: #fff; }
  to { background: $text-color; }
}

@keyframes opaqueFade {
  from { opacity: 1; }
  to { opacity: 0; }
}
</style>
